commit 78b92b33da557fd860ce419aeab1fe7cfde15605
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Oct 31 14:40:32 2019 +0100

    removed the CORTEX_VTOR_INIT macro from all chconf.h files since this setting is deprecated (information is now retrieved from linker files)

diff --git a/modules/DiWheelDrive_1-1/chconf.h b/modules/DiWheelDrive_1-1/chconf.h
index d8de561..e3f5064 100644
--- a/modules/DiWheelDrive_1-1/chconf.h
+++ b/modules/DiWheelDrive_1-1/chconf.h
@@ -136,12 +136,6 @@
 /*===========================================================================*/
 
 /**
- * @brief   NVIC VTOR initialization offset.
- * @details On initialization, the code at this address in the flash memory will be executed.
- */
-#define CORTEX_VTOR_INIT                        0x00006000U
-
-/**
  * @brief   Flag to enable/disable sleep mode when the system is idle.
  */
 #define CORTEX_ENABLE_WFI_IDLE                  TRUE
diff --git a/modules/DiWheelDrive_1-2/chconf.h b/modules/DiWheelDrive_1-2/chconf.h
index 92dc2d1..10eb0a8 100644
--- a/modules/DiWheelDrive_1-2/chconf.h
+++ b/modules/DiWheelDrive_1-2/chconf.h
@@ -136,12 +136,6 @@
 /*===========================================================================*/
 
 /**
- * @brief   NVIC VTOR initialization offset.
- * @details On initialization, the code at this address in the flash memory will be executed.
- */
-#define CORTEX_VTOR_INIT                        0x00006000U
-
-/**
  * @brief   Flag to enable/disable sleep mode when the system is idle.
  */
 #define CORTEX_ENABLE_WFI_IDLE                  TRUE
diff --git a/modules/LightRing_1-0/chconf.h b/modules/LightRing_1-0/chconf.h
index 973844c..bf18599 100644
--- a/modules/LightRing_1-0/chconf.h
+++ b/modules/LightRing_1-0/chconf.h
@@ -136,12 +136,6 @@
 /*===========================================================================*/
 
 /**
- * @brief   NVIC VTOR initialization offset.
- * @details On initialization, the code at this address in the flash memory will be executed.
- */
-#define CORTEX_VTOR_INIT                        0x00006000U
-
-/**
  * @brief   Flag to enable/disable sleep mode when the system is idle.
  */
 #define CORTEX_ENABLE_WFI_IDLE                  TRUE
diff --git a/modules/LightRing_1-2/chconf.h b/modules/LightRing_1-2/chconf.h
index 07588f2..093b438 100644
--- a/modules/LightRing_1-2/chconf.h
+++ b/modules/LightRing_1-2/chconf.h
@@ -136,12 +136,6 @@
 /*===========================================================================*/
 
 /**
- * @brief   NVIC VTOR initialization offset.
- * @details On initialization, the code at this address in the flash memory will be executed.
- */
-#define CORTEX_VTOR_INIT                        0x00006000U
-
-/**
  * @brief   Flag to enable/disable sleep mode when the system is idle.
  */
 #define CORTEX_ENABLE_WFI_IDLE                  TRUE
diff --git a/modules/PowerManagement_1-1/chconf.h b/modules/PowerManagement_1-1/chconf.h
index e955874..a25b20b 100644
--- a/modules/PowerManagement_1-1/chconf.h
+++ b/modules/PowerManagement_1-1/chconf.h
@@ -136,12 +136,6 @@
 /*===========================================================================*/
 
 /**
- * @brief   NVIC VTOR initialization offset.
- * @details On initialization, the code at this address in the flash memory will be executed.
- */
-#define CORTEX_VTOR_INIT                        0x00008000U
-
-/**
  * @brief   Flag to enable/disable sleep mode when the system is idle.
  */
 #define CORTEX_ENABLE_WFI_IDLE                  TRUE
diff --git a/modules/PowerManagement_1-2/chconf.h b/modules/PowerManagement_1-2/chconf.h
index 55dbe38..7d00cb7 100644
--- a/modules/PowerManagement_1-2/chconf.h
+++ b/modules/PowerManagement_1-2/chconf.h
@@ -136,12 +136,6 @@
 /*===========================================================================*/
 
 /**
- * @brief   NVIC VTOR initialization offset.
- * @details On initialization, the code at this address in the flash memory will be executed.
- */
-#define CORTEX_VTOR_INIT                        0x00008000U
-
-/**
  * @brief   Flag to enable/disable sleep mode when the system is idle.
  */
 #define CORTEX_ENABLE_WFI_IDLE                  TRUE