commit 3cb82b1a0c9daa8512ed85a08aff8e4cc59040b4
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Feb 14 11:10:40 2019 +0100

    Reordered some configuration files.
    The BOARD_VERSION macro has been removed. Instead the version is now encoded in the other BOARD_XXX macros.

diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index 2c9da7c..947032f 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -265,11 +265,7 @@ static void _printSystemInfo(BaseSequentialStream* stream)
 
   // print static information about module and operating system
   _printSystemInfoSeparator(stream, '=', SYSTEM_INFO_WIDTH);
-#ifdef BOARD_VERSION
-  _printSystemInfoLine(stream, "Module", SYSTEM_INFO_NAMEWIDTH, "%s (v%s)", BOARD_NAME, BOARD_VERSION);
-#else
   _printSystemInfoLine(stream, "Module", SYSTEM_INFO_NAMEWIDTH, "%s", BOARD_NAME);
-#endif
 #ifdef PLATFORM_NAME
   _printSystemInfoLine(stream, "Platform", SYSTEM_INFO_NAMEWIDTH, "%s", PLATFORM_NAME);
 #endif
diff --git a/modules/DiWheelDrive_1-1/board.h b/modules/DiWheelDrive_1-1/board.h
index 2808ec7..18f5cd2 100644
--- a/modules/DiWheelDrive_1-1/board.h
+++ b/modules/DiWheelDrive_1-1/board.h
@@ -34,9 +34,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /*
  * Board identifier.
  */
-#define BOARD_DIWHEELDRIVE
-#define BOARD_NAME              "AMiRo DiWheelDrive"
-#define BOARD_VERSION           "1.1"
+#define BOARD_DIWHEELDRIVE_1_1
+#define BOARD_NAME              "AMiRo DiWheelDrive v1.1"
 
 /*
  * Board oscillators-related settings.
diff --git a/modules/DiWheelDrive_1-1/mcuconf.h b/modules/DiWheelDrive_1-1/mcuconf.h
index 15fad6c..27f8026 100644
--- a/modules/DiWheelDrive_1-1/mcuconf.h
+++ b/modules/DiWheelDrive_1-1/mcuconf.h
@@ -19,8 +19,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #ifndef MCUCONF_H
 #define MCUCONF_H
 
-#define STM32F103_MCUCONF
-
 /*
  * STM32F103 drivers configuration.
  * The following settings override the default settings present in
@@ -35,6 +33,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * 0...3        Lowest...Highest.
  */
 
+#define STM32F103_MCUCONF
+
 /*
  * HAL driver system settings.
  */
diff --git a/modules/LightRing_1-0/board.h b/modules/LightRing_1-0/board.h
index fa2a713..b9385ea 100644
--- a/modules/LightRing_1-0/board.h
+++ b/modules/LightRing_1-0/board.h
@@ -34,9 +34,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /*
  * Board identifier.
  */
-#define BOARD_LIGHTRING
-#define BOARD_NAME              "AMiRo LightRing"
-#define BOARD_VERSION           "1.0"
+#define BOARD_LIGHTRING_1_0
+#define BOARD_NAME              "AMiRo LightRing v1.0"
 
 /*
  * Board oscillators-related settings.
diff --git a/modules/LightRing_1-0/mcuconf.h b/modules/LightRing_1-0/mcuconf.h
index 8aa63b0..28ce35f 100644
--- a/modules/LightRing_1-0/mcuconf.h
+++ b/modules/LightRing_1-0/mcuconf.h
@@ -19,8 +19,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #ifndef MCUCONF_H
 #define MCUCONF_H
 
-#define STM32F103_MCUCONF
-
 /*
  * STM32F103 drivers configuration.
  * The following settings override the default settings present in
@@ -35,6 +33,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * 0...3        Lowest...Highest.
  */
 
+#define STM32F103_MCUCONF
+
 /*
  * HAL driver system settings.
  */
diff --git a/modules/NUCLEO-L476RG/board.h b/modules/NUCLEO-L476RG/board.h
index 11fba55..fab728d 100644
--- a/modules/NUCLEO-L476RG/board.h
+++ b/modules/NUCLEO-L476RG/board.h
@@ -32,7 +32,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define BOARD_ST_NUCLEO64_L476RG
 #define BOARD_NAME                  "STMicroelectronics STM32 Nucleo64-L476RG"
-#define BOARD_VERSION           "1.0"
 
 /*
  * Board oscillators-related settings.
diff --git a/modules/PowerManagement_1-1/board.h b/modules/PowerManagement_1-1/board.h
index eaded06..e20f053 100644
--- a/modules/PowerManagement_1-1/board.h
+++ b/modules/PowerManagement_1-1/board.h
@@ -34,9 +34,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /*
  * Board identifier.
  */
-#define BOARD_POWERMANAGEMENT
-#define BOARD_NAME                      "AMiRo PowerManagement"
-#define BOARD_VERSION                   "1.1"
+#define BOARD_POWERMANAGEMENT_1_1
+#define BOARD_NAME                      "AMiRo PowerManagement v1.1"
 
 /*
  * Board oscillators-related settings.
diff --git a/modules/PowerManagement_1-1/mcuconf.h b/modules/PowerManagement_1-1/mcuconf.h
index a178a34..e1abd26 100644
--- a/modules/PowerManagement_1-1/mcuconf.h
+++ b/modules/PowerManagement_1-1/mcuconf.h
@@ -19,15 +19,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #ifndef MCUCONF_H
 #define MCUCONF_H
 
-#define STM32F4xx_MCUCONF
-
-/*
- * Some old revisions of F4x MCU randomly chrashes with certain compiler options enabled.
- * This flag makes the kernel dynamically detect the MCUs ID code and CPU ID and react accordingly.
- * (see ChibiOS kernel: os/hal/ports/STM32/STM32F4xx/hal_lld.c)
- */
-#define STM32_USE_REVISION_A_FIX
-
 /*
  * STM32F4xx drivers configuration.
  * The following settings override the default settings present in
@@ -42,6 +33,15 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * 0...3        Lowest...Highest.
  */
 
+#define STM32F4xx_MCUCONF
+
+/*
+ * Some old revisions of F4x MCU randomly chrashes with certain compiler options enabled.
+ * This flag makes the kernel dynamically detect the MCUs ID code and CPU ID and react accordingly.
+ * (see ChibiOS kernel: os/hal/ports/STM32/STM32F4xx/hal_lld.c)
+ */
+#define STM32_USE_REVISION_A_FIX
+
 /*
  * HAL driver system settings.
  */