commit 83e58975ffeaa75f474765f7b50812e6d96deefe
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Oct 31 14:38:33 2019 +0100

    minor code optimizations to get rid or clang warnings

diff --git a/core/inc/aos_debug.h b/core/inc/aos_debug.h
index b994f85..4353ee4 100644
--- a/core/inc/aos_debug.h
+++ b/core/inc/aos_debug.h
@@ -64,12 +64,12 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @param[in] c The condition to be verified to be true.
  */
-#define aosDbgCheck(c) {                                                      \
+#define aosDbgCheck(c) do {                                                   \
   if (!(c)) {                                                                 \
     aosDbgPrintf("%s(%u): aosDbgCheck failed", __FILE__, __LINE__);           \
     chThdExit(MSG_RESET);                                                     \
   }                                                                           \
-}
+} while (false)
 
 /**
  * @brief   Condition assertion.
@@ -77,12 +77,12 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @param[in] c The condition to be verified to be true.
  */
-#define aosDbgAssert(c) {                                                     \
+#define aosDbgAssert(c) do {                                                  \
   if (!(c)) {                                                                 \
     aosDbgPrintf("%s(%u): aosDbgAssert failed", __FILE__, __LINE__);          \
     chThdExit(MSG_RESET);                                                     \
   }                                                                           \
-}
+} while (false)
 
 /**
  * @brief   Condition assertion.
@@ -91,31 +91,27 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @param[in] c The condition to be verified to be true.
  * @param[in] r A custom remark string.
  */
-#define aosDbgAssertMsg(c, fmt, ...) {                                        \
+#define aosDbgAssertMsg(c, fmt, ...) do {                                     \
   if (!(c)) {                                                                 \
     aosDbgPrintf(fmt, ##__VA_ARGS__);                                         \
     chThdExit(MSG_RESET);                                                     \
   }                                                                           \
-}
+} while (false)
 
 #else /* (AMIROOS_CFG_DBG == true) */
 
-#define aosDbgPrintf(fmt, ...) {                          \
-  (void)(fmt);                                            \
-}
+#define aosDbgPrintf(fmt, ...)                                                \
+  (void)(fmt)
 
-#define aosDbgCheck(c) {                                  \
-  (void)(c);                                              \
-  }
+#define aosDbgCheck(c)                                                        \
+  (void)(c)
 
-#define aosDbgAssert(c) {                                 \
-  (void)(c);                                              \
-}
+#define aosDbgAssert(c)                                                       \
+  (void)(c)
 
-#define aosDbgAssertMsg(c, r) {                           \
-  (void)(c);                                              \
-  (void)(r);                                              \
-}
+#define aosDbgAssertMsg(c, r)                                                 \
+  (void)(c);                                                                  \
+  (void)(r)
 
 #endif /* (AMIROOS_CFG_DBG == true) */
 
diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index a2773a7..b346a10 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -192,7 +192,7 @@ static unsigned int _printSystemInfoSeparator(BaseSequentialStream* stream, cons
 
   // print the specified character n times
   for (unsigned int i = 0; i < n; ++i) {
-    streamPut(stream, c);
+    streamPut(stream, (uint8_t)c);
   }
   streamPut(stream, '\n');
 
@@ -222,12 +222,12 @@ static unsigned int _printSystemInfoLine(BaseSequentialStream* stream, const cha
   va_list ap;
 
   va_start(ap, fmt);
-  n += chprintf(stream, name);
+  n += (unsigned int)chprintf(stream, name);
   while (n < namewidth) {
     streamPut(stream, ' ');
     ++n;
   }
-  n += chvprintf(stream, fmt, ap);
+  n += (unsigned int)chvprintf(stream, fmt, ap);
   va_end(ap);
 
   streamPut(stream, '\n');
@@ -458,7 +458,7 @@ static int _shellcmd_configcb(BaseSequentialStream* stream, int argc, char* argv
         chprintf(stream, "unknown option '%s' or invalid value '%s'\n", argv[2], argv[3]);
         return AOS_INVALIDARGUMENTS;
       }
-      dt.tm_wday = aosTimeDayOfWeekFromDate(dt.tm_mday, dt.tm_mon+1, dt.tm_year+1900) % 7;
+      dt.tm_wday = aosTimeDayOfWeekFromDate((uint16_t)dt.tm_mday, (uint8_t)dt.tm_mon+1, (uint16_t)dt.tm_year+1900) % DAYS_PER_WEEK;
       aosSysSetDateTime(&dt);
 
       // read and print new date and time
@@ -535,7 +535,7 @@ static int _shellcmd_infocb(BaseSequentialStream* stream, int argc, char* argv[]
   chprintf(stream, "%10u milliseconds\n", (uint16_t)(uptime % MICROSECONDS_PER_SECOND / MICROSECONDS_PER_MILLISECOND));
   chprintf(stream, "%10u microseconds\n", (uint16_t)(uptime % MICROSECONDS_PER_MILLISECOND / MICROSECONDS_PER_MICROSECOND));
 #if (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true)
-  chprintf(stream, "SSSP synchronization offset: %.3fus per %uus\n", _syssyncskew, AMIROOS_CFG_SSSP_SYSSYNCPERIOD);
+  chprintf(stream, "SSSP synchronization offset: %.3fus per %uus\n", (double)_syssyncskew, AMIROOS_CFG_SSSP_SYSSYNCPERIOD);
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_MASTER != true) && (AMIROOS_CFG_PROFILE == true) */
   _printSystemInfoSeparator(stream, '=', SYSTEM_INFO_WIDTH);
 
@@ -547,7 +547,7 @@ static int _shellcmd_infocb(BaseSequentialStream* stream, int argc, char* argv[]
 #if (AMIROOS_CFG_DBG == true)
   chprintf(stream, "\tthread stack size:      %u bytes\n", aosThdGetStacksize(aos.shell.thread));
 #if (CH_DBG_FILL_THREADS == TRUE)
-  chprintf(stream, "\tstack peak utilization: %u bytes (%.2f%%)\n", aosThdGetStackPeakUtilization(aos.shell.thread), (float)(aosThdGetStackPeakUtilization(aos.shell.thread)) / (float)(aosThdGetStacksize(aos.shell.thread)) * 100.0f);
+  chprintf(stream, "\tstack peak utilization: %u bytes (%.2f%%)\n", aosThdGetStackPeakUtilization(aos.shell.thread), (double)((float)(aosThdGetStackPeakUtilization(aos.shell.thread)) / (float)(aosThdGetStacksize(aos.shell.thread)) * 100.0f));
 #endif /* (CH_DBG_FILL_THREADS == TRUE) */
 #endif /* (AMIROOS_CFG_DBG == true) */
   _printSystemInfoSeparator(stream, '=', SYSTEM_INFO_WIDTH);
@@ -877,7 +877,7 @@ void aosSysInit(const char* shellPrompt)
 /**
  * @brief   Starts the system and all system threads.
  */
-inline void aosSysStart(void)
+void aosSysStart(void)
 {
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
   // update the system SSSP stage
@@ -971,7 +971,7 @@ eventmask_t aosSysSsspStartupOsInitSyncCheck(event_listener_t* syncEvtListener)
  *
  * @param[out] ut   The system uptime.
  */
-inline void aosSysGetUptimeX(aos_timestamp_t* ut)
+void aosSysGetUptimeX(aos_timestamp_t* ut)
 {
   aosDbgCheck(ut != NULL);
 
diff --git a/modules/LightRing_1-2/board.h b/modules/LightRing_1-2/board.h
index 7ea2f11..46db6d7 100644
--- a/modules/LightRing_1-2/board.h
+++ b/modules/LightRing_1-2/board.h
@@ -67,10 +67,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define BOARD_BREAKOUT_UWBv10       1
 
 /*
- * Configuration macro to define which type of sensor ring is attached.
+ * Configuration macro to define which breakout module is attached.
  */
 #if !defined(BOARD_BREAKOUT_MODULE) || defined(__DOXYGEN__)
-#define BOARD_BREAKOUT_MODULE       BOARD_BREAKOUT_UWBv10
+#define BOARD_BREAKOUT_MODULE       BOARD_BREAKOUT_NONE
 #endif
 
 /*